import numpy as np
from _typeshed import Incomplete
from edgeiq import bounding_box as bounding_box, constants as constants, processing as processing
from edgeiq._production_client import PRODUCTION_CLIENT as PRODUCTION_CLIENT
from edgeiq.base_service import BaseService as BaseService
from edgeiq.edge_tools import to_json_serializable as to_json_serializable
from typing import Any

SUPPORTED_ENGINES: Incomplete

class ObjectDetectionPrediction(bounding_box.BoundingBoxPrediction):
    def __init__(self, box: bounding_box.BoundingBox, confidence: float, label: str, index: int) -> None: ...
    def __eq__(self, other) -> bool: ...
    @property
    def label(self) -> str: ...
    @label.setter
    def label(self, label: str): ...
    @property
    def index(self) -> int: ...

class ObjectDetectionResults:
    def __init__(self, predictions: list, duration: float, image: np.ndarray, **kwargs) -> None: ...
    def __eq__(self, other) -> bool: ...
    @property
    def duration(self) -> float: ...
    @property
    def predictions(self) -> list: ...
    @predictions.setter
    def predictions(self, predictions: list): ...
    @property
    def image(self) -> np.ndarray: ...

RESULT_TYPE: Incomplete

class ObjectDetection(BaseService):
    def __init__(self, model_id: str) -> None: ...
    def detect_objects(self, image: np.ndarray, confidence_level: float = ..., overlap_threshold: float = ...) -> ObjectDetectionResults: ...
    def publish_analytics(self, results: ObjectDetectionResults, tag: Any = ...): ...
